#
# Conditional build:
%bcond_without	gstreamer	# GStreamer-based video support
%bcond_without	js		# JavaScript support
%bcond_with	pdf		# PDF export and GTK+ printing support via libharu [needs update?]
%bcond_without	webp		# WebP image support
#
Summary:	Light WWW browser with CSS support
Summary(pl.UTF-8):	Lekka przeglądarka WWW z obsługą CSS
Name:		netsurf
Version:	3.3
Release:	1
License:	GPL v2 with OpenSSL exception (code), MIT (artwork)
Group:		Applications/Networking
Source0:	http://download.netsurf-browser.org/netsurf/releases/source/%{name}-%{version}-src.tar.gz
# Source0-md5:	81a2838d8816ea435c4471f515a397d4
Source1:	%{name}.desktop
Patch0:		nsfb-ldflags.patch
Patch1:		%{name}-link.patch
Patch2:		no-Werror.patch
Patch3:		optflags.patch
Patch4:		jsapi_h.patch
URL:		http://netsurf-browser.org/
BuildRequires:	curl-devel
BuildRequires:	freetype-devel >= 2
%{?with_gstreamer:BuildRequires:	gstreamer0.10-devel >= 0.10}
BuildRequires:	gtk+2-devel >= 2.0
%{?with_js:BuildRequires:	js187-devel}
BuildRequires:	libCSS-devel >= 0.5.0
BuildRequires:	libdom-devel >= 0.1.2
%{?with_pdf:BuildRequires:	libharu-devel}
BuildRequires:	libhubbub-devel >= 0.3.1
BuildRequires:	libjpeg-devel
BuildRequires:	libnsbmp-devel >= 0.1.2
BuildRequires:	libnsfb-devel >= 0.1.3
BuildRequires:	libnsgif-devel >= 0.1.2
BuildRequires:	libnsutils-devel >= 0.0.1
BuildRequires:	libparserutils-devel >= 0.2.1
BuildRequires:	libpng-devel
BuildRequires:	librsvg-devel
BuildRequires:	libsvgtiny-devel >= 0.1.3
BuildRequires:	libutf8proc-devel >= 1.1.6
BuildRequires:	libwapcaplet-devel >= 0.2.2
%{?with_webp:BuildRequires:	libwebp-devel}
BuildRequires:	openssl-devel
BuildRequires:	netsurf-buildsystem >= 1.3
BuildRequires:	nsgenbind >= 0.1.2
BuildRequires:	perl-HTML-Parser
BuildRequires:	pkgconfig
BuildRequires:	sed >= 4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
NetSurf is a multi-platform lightweight web browser. Its aim is to
provide comprehensive rendering of HTML 5 with CSS 2 in a small
resource footprint while remaining fast.

%description -l pl.UTF-8
NetSurf to wieloplatformowa, lekka przeglądarka WWW. Celem jest
zapewnienie kompletnego renderowania HTML 5 z CSS 2 przy małym
wykorzystanie zasobów, z zachowaniem dużej szybkości.

%package common
Summary:	NetSurf - common files
Summary(pl.UTF-8):	NetSurf - pliki wspólne
Group:		Applications/Networking

%description common
NetSurf - common files.

%description common -l pl.UTF-8
NetSurf - wspólne pliki.

%package gtk
Summary:	NetSurf web browser - GTK+ version
Summary(pl.UTF-8):	Wersja GTK+ przeglądarki WWW NetSurf
Group:		Applications/Networking
Requires:	%{name}-common = %{version}-%{release}
Requires:	libCSS >= 0.4.0
Requires:	libdom >= 0.1.1
Requires:	libhubbub >= 0.3.0
Requires:	libnsbmp >= 0.1.1
Requires:	libnsgif >= 0.1.1
Requires:	libparserutils >= 0.2.0
Requires:	libsvgtiny >= 0.1.2
Requires:	libwapcaplet >= 0.2.1

%description gtk
NetSurf is a multi-platform lightweight web browser. Its aim is to
provide comprehensive rendering of HTML 5 with CSS 2 in a small
resource footprint while remaining fast.

This package contains GTK+ version.

%description gtk -l pl.UTF-8
NetSurf to wieloplatformowa, lekka przeglądarka WWW. Celem jest
zapewnienie kompletnego renderowania HTML 5 z CSS 2 przy małym
wykorzystanie zasobów, z zachowaniem dużej szybkości.

Ten pakiet zawiera wersję GTK+.

%package sdl
Summary:	NetSurf web browser - SDL version
Summary(pl.UTF-8):	Wersja SDL przeglądarki WWW NetSurf
Group:		Applications/Networking
Requires:	%{name}-common = %{version}-%{release}
Requires:	libCSS >= 0.4.0
Requires:	libdom >= 0.1.1
Requires:	libhubbub >= 0.3.0
Requires:	libnsbmp >= 0.1.1
Requires:	libnsfb >= 0.1.2
Requires:	libnsgif >= 0.1.1
Requires:	libparserutils >= 0.2.0
Requires:	libsvgtiny >= 0.1.2
Requires:	libwapcaplet >= 0.2.1

%description sdl
NetSurf is a multi-platform lightweight web browser. Its aim is to
provide comprehensive rendering of HTML 5 with CSS 2 in a small
resource footprint while remaining fast.

This package contains SDL version.

%description sdl -l pl.UTF-8
NetSurf to wieloplatformowa, lekka przeglądarka WWW. Celem jest
zapewnienie kompletnego renderowania HTML 5 z CSS 2 przy małym
wykorzystanie zasobów, z zachowaniem dużej szybkości.

Ten pakiet zawiera wersję SDL.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

cat << EOF > Makefile.config
NETSURF_FB_FONTLIB := freetype
NETSURF_FB_FONTPATH := %{_datadir}/fonts/TTF
NETSURF_USE_NSSVG := YES
NETSURF_USE_RSVG := YES
%{?with_webp:NETSURF_USE_WEBP := YES}
%{?with_gstreamer:NETSURF_USE_VIDEO := YES}
%{?with_pdf:NETSURF_USE_HARU_PDF := YES}
# js187
%if %{with js}
NETSURF_USE_MOZJS := YES
%else
NETSURF_USE_MOZJS := NO
%endif
# xulrunner
NETSURF_USE_JS := NO
EOF

%if %{with gstreamer}
# GStreamer 0.10 uses now deprecated glib mutex APIs
%{__sed} -i -e '/-DG_DISABLE_DEPRECATED/d' gtk/Makefile.target
%endif
# gdk-pixbuf 2.31 deprecates GdkPixdata
%{__sed} -i -e '/-DGDK_PIXBUF_DISABLE_DEPRECATED/d' gtk/Makefile.target

%build
export CC="%{__cc}"
# while cxx not needed, somewhy it helps race condition on carme build
export CXX="%{__cxx}"
# silence -Werror:
#src/surface/vnc.c: In function 'vnc_input':
#src/surface/vnc.c:489:9: error: variable 'ret' set but not used [-Werror=unused-but-set-variable]
export CFLAGS="%{rpmcflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE"
export CXXFLAGS="%{rpmcxxflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE"
export LDFLAGS="%{rpmldflags}"

# make -j1 or it won't find libwapcaplet/libwapcaplet.h

%{__make} -j1 \
	OPTFLAGS="%{rpmcflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE" \
	OPTLDFLAGS="%{rpmldflags}" \
	PREFIX=%{_prefix} \
	Q='' \
	TARGET=gtk

%{__make} -j1 \
	OPTFLAGS="%{rpmcflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE" \
	OPTLDFLAGS="%{rpmldflags}" \
	PREFIX=%{_prefix} \
	Q='' \
	TARGET=framebuffer

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	Q='' \
	PREFIX=%{_prefix} \
	TARGET=gtk \
	DESTDIR=$RPM_BUILD_ROOT


%{__make} install \
	Q='' \
	PREFIX=%{_prefix} \
	TARGET=framebuffer \
	DESTDIR=$RPM_BUILD_ROOT

# this is binary from last "make install", we install more specific binary ourself
%{__rm} -f $RPM_BUILD_ROOT%{_bindir}/netsurf

install -d $RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir}}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_desktopdir}
install nsfb $RPM_BUILD_ROOT%{_bindir}
install nsgtk $RPM_BUILD_ROOT%{_bindir}

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(644,root,root,755)
%doc COPYING README
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*

%files gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/nsgtk
%{_desktopdir}/netsurf.desktop

%files sdl
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/nsfb
%changelog
* Sun Aug 09 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/netsurf.git;a=log;h=master

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 94e17ef
- more js187 fixes

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 0b77bda
- update js version in Makefile

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> f37fbad
- bump js req to 187

* Mon Mar 16 2015 Witold Filipczyk <witekfl@poczta.onet.pl> 19c141f
- updated to 3.3
- added jsapi_h.patch

* Tue Dec 02 2014 Jakub Bogusz <qboosh@pld-linux.org> 5a1b122
- fixed build with gdk-pixbuf 2.31.x
- libglade no longer needed

* Mon Dec 01 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 3df4878
- bcond js. Javascript support is very poor
- increased the nsgenbind version number in BR.

* Mon Dec 01 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 5eeba20
- updated to 3.2
- disabled xulrunner, enabled js185

* Tue Nov 25 2014 Jan Rękorajski <baggins@pld-linux.org> 0bb73e3
- fix passing CFLAGS/LDFLAGS
- rel 3

* Tue Nov 25 2014 Jan Rękorajski <baggins@pld-linux.org> 4285513
- drop Werror (fails to build on current glibc)
- rel 2

* Tue Jun 24 2014 Jakub Bogusz <qboosh@pld-linux.org> f2c002f
- fixed pl descriptions

* Wed May 14 2014 Jakub Bogusz <qboosh@pld-linux.org> 17158ae
- enabled gstreamer and webp support (with bconds)
- added link patch to fix nsfb linking when additional features are enabled

* Wed Apr 30 2014 Witold Filipczyk <witekfl@poczta.onet.pl> e49db76
- deleted obsolete patches

* Wed Apr 30 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 5a27c21
- obsolete

* Wed Apr 30 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 4c7a6fc
- obsolete

* Wed Apr 30 2014 Witold Filipczyk <witekfl@poczta.onet.pl> d3ed32a
- one can exit using mouse

* Wed Apr 30 2014 Witold Filipczyk <witekfl@poczta.onet.pl> fb57e30
- obsolete

* Tue Apr 29 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 6c09c25
- up to 3.1
- adjusted BRs

* Tue Apr 29 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 273a5aa
- adjusted for metsurf-3.1

* Sun Feb 09 2014 Elan Ruusamäe <glen@delfi.ee> 51a5e7c
- fix desktopfile

* Wed Feb 05 2014 Jan Rękorajski <baggins@pld-linux.org> 6b34a8f
- rebuild with libmng 2.0.2
- release 4 (by relup.sh)

